const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const boms = sequelize.define(
    'boms',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

bom_code: {
        type: DataTypes.TEXT,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"active",


"archived"

        ],

      },

yield_qty: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  boms.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



















    db.boms.hasMany(db.bom_items, {
      as: 'bom_items_bom',
      foreignKey: {
          name: 'bomId',
      },
      constraints: false,
    });





    db.boms.hasMany(db.work_orders, {
      as: 'work_orders_bom',
      foreignKey: {
          name: 'bomId',
      },
      constraints: false,
    });










//end loop



    db.boms.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });




    db.boms.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.boms.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return boms;
};


